clear all;
clc;

% ATENCION ... ES UNA GUIA!!!!!!!

    % cuantificador
    Q=[16 11 10 16 24 40 51 61;
       12 12 14 19 26 58 60 55;
       14 13 16 24 40 57 69 56;
       14 17 22 29 51 87 80 62;
       18 22 37 56 68 109 103 77;
       24 35 55 64 81 104 113 92;
       49 64 78 87 103 121 120 101;
       72 92 95 98 112 100 103 99];

   A=[87 89 101 106 118 130 142 155;
        85 91 101 105 116 129 135 149;
        86 92 96 105 112 128 131 144;
        92 88 102 101 116 129 135 147;
        88 94 94 98 113 122 130 139;
        88 95 98 97 113 119 133 141;
        92 99 98 106 107 118 135 145;
        89 95 98 107 104 112 130 144];
   

% Lenna
imagen = imread('lenna256.bmp','bmp');
% fin Lenna
imagen=uint8(A);

[filas,columnas]=size(imagen);

% prediccion espacial (segunda parte)

% fin prediccion

imagen_dct=zeros(filas,columnas);
imagen_deco=uint8(zeros(filas,columnas));
imagen_error=zeros(filas,columnas);

for i=0:8:filas-8
    for j=0:8:columnas-8
% Dividir la imagen en bloques 8x8 y ...
    bloque(1:8,1:8)=imagen(i+1:i+8,j+1:j+8);
    % aplicar la DCT
    dctBloque=...;
    % cuantificar dividiendo por Q y redondeando a entero
    cuantificada=...;
    % reconstruir multiplicando por Q
    deCuantificada=...;
    % aplicar la IDCT
    idctBloque=...
    % calcular el bloque de error
    error=double(bloque)-double(idctBloque);
   
            
   imagen_bloques(i+1:i+8,j+1:j+8)=bloque(1:8,1:8);
   imagen_dct(i+1:i+8,j+1:j+8)=cuantificada(1:8,1:8);
   imagen_deco(i+1:i+8,j+1:j+8)=idctBloque(1:8,1:8);
   imagen_error(i+1:i+8,j+1:j+8)=error(1:8,1:8);
        
    end
end

    
 imwrite(imagen_bloques,'imagenbloques.bmp','bmp');
 imwrite(imagen_dct,'imagendct.bmp','bmp');
 imwrite(imagen_deco,'imagendeco.bmp','bmp');
 imwrite(imagen_error,'imagenerror.bmp','bmp');

    
% HISTOGRAMAS
   
figure;
nbins=256;

h_ima=imagen(1,:);
h_dct=imagen_dct(1,:);
h_deco=imagen_deco(1,:);
h_error=imagen_error(1,:);
for i=2:filas
    h_ima=[h_ima imagen(i,:)];
    h_dct=[h_dct imagen_dct(i,:)];
    h_deco=[h_deco imagen_deco(i,:)];
    h_error=[h_error imagen_error(i,:)];
end

subplot(2,2,1);
[n,xout]=hist(double(h_ima),nbins);
bar(xout,n);
title('Hist(imagen)');
   
subplot(2,2,2);
[n,xout]=hist(h_dct,nbins);
bar(xout,n);
title('Hist(imagen dct)');

subplot(2,2,3);
[n,xout]=hist(double(h_deco),nbins);
bar(xout,n);
title('Hist(imagen deco)');

subplot(2,2,4);
[n,xout]=hist(h_error,nbins);
bar(xout,n);
title('Hist(imagen error)');

